﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Assertions;

public class LevelMenuController : MonoBehaviour {

	public string correctAnswer;
	public GameObject inputFieldObject;
	public GameObject checkButtonObject;
	public GameObject resultTextObject;
	public GameObject continueButtonObject;

	InputField inputField;
	Text resultText;

	void Awake () {
		assertAllSetUp ();
		initComponents ();
		setUpPanel ();
	}

	void assertAllSetUp(){
		Assert.IsNotNull (correctAnswer);
		Assert.IsNotNull (inputFieldObject);
		Assert.IsNotNull (checkButtonObject);
		Assert.IsNotNull (resultTextObject);
		Assert.IsNotNull (continueButtonObject);
	}

	void initComponents(){
		inputField = inputFieldObject.GetComponent<InputField> ();
		resultText = resultTextObject.GetComponent<Text> ();
	}

	void setUpPanel(){
		inputFieldObject.SetActive (true);
		checkButtonObject.SetActive (true);
		resultTextObject.SetActive (false);
		continueButtonObject.SetActive (false);
	}

	public void tryLevel(){
		resultTextObject.SetActive (false);
		inputField = inputFieldObject.GetComponent<InputField> ();
		if (answerIsCorrect (inputField.text)) {
			inputFieldObject.SetActive (false);
			checkButtonObject.SetActive (false);
			resultText.text = "Es correcto!!!";
			resultText.color = Color.green;
			resultTextObject.SetActive (true);
			continueButtonObject.SetActive (true);
		} else {
			resultText.text = "No es correcto. Vuelve a intentarlo.";
			resultText.color = Color.red;
			resultTextObject.SetActive (true);
		}
	}

	bool answerIsCorrect(string answer){
		return answer == correctAnswer;
	}

	public void nextLevel(){
		GameObject gameControllerObject = GameObject.FindGameObjectWithTag ("GameController");
		GameController gameController = gameControllerObject.GetComponent<GameController> ();
		gameController.returnFromLevel ();
	}
}
