﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MainCameraController : MonoBehaviour {

	public float smoothTime = 1f;

	Transform target;
	float topLeftX, topLeftY, bottomRightX, bottomRightY;
	Vector2 velocity;

	void Awake(){
		setTargetToPlayer ();
	}
	
	// Update is called once per frame
	void Update () {
		moveSoftWithTarget ();
	}

	void moveSoftWithTarget(){
		float smoothedX = Mathf.SmoothDamp (transform.position.x, target.position.x, ref velocity.x, smoothTime);
		float smoothedY = Mathf.SmoothDamp (transform.position.y, target.position.y, ref velocity.y, smoothTime);
		float x = Mathf.Round (smoothedX * 100) / 100;
		float y = Mathf.Round (smoothedY * 100) / 100;

		transform.position = new Vector3 (
			Mathf.Clamp(x, topLeftX, bottomRightX),
			Mathf.Clamp(y, bottomRightY, topLeftY),
			transform.position.z
		);
	}

	public void setCameraBounds(GameObject map){
		Tiled2Unity.TiledMap tiledMap = map.GetComponent<Tiled2Unity.TiledMap> ();
		float cameraSize = Camera.main.orthographicSize;

		topLeftX = map.transform.position.x + cameraSize;
		topLeftY = map.transform.position.y - cameraSize;
		bottomRightX = map.transform.position.x + tiledMap.NumTilesWide - cameraSize;
		bottomRightY = map.transform.position.y - tiledMap.NumTilesHigh + cameraSize;

		fastMove ();
	}

	void setTargetToPlayer (){
		GameObject player = GameObject.FindGameObjectWithTag ("Player");
		target = player.transform;
	}

	void fastMove(){
		transform.position = new Vector3 (
			Mathf.Clamp(target.position.x, topLeftX, bottomRightX),
			Mathf.Clamp(target.position.y, bottomRightY, topLeftY),
			transform.position.z
		);
	}
		
}
