﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Assertions;

public class PlayerController : MonoBehaviour {

	public float speed = 5f;
	public GameObject initialMap;

	Animator playerAnimator;
	Rigidbody2D playerRigidBody;
	GameController gameController;

	Vector2 mov;

	void Awake() {
		assertAllSetUp ();
	}

	// Use this for initialization
	void Start () {
		initComponents ();
		setUpCameraToInitialMap ();
	}
	
	// Update is called once per frame
	void Update () {
		if (!gameController.isGamePaused ()) {
			readNextMov ();
			setAnimatorParams ();
		}
	}

	void FixedUpdate(){
		movePlayerTowardsMov ();
	}

	void assertAllSetUp(){
		Assert.IsNotNull (initialMap);
	}

	void initComponents (){
		playerAnimator = GetComponent<Animator> ();
		playerRigidBody = GetComponent<Rigidbody2D> ();
		GameObject gameControllerObject = GameObject.FindGameObjectWithTag ("GameController");
		gameController = gameControllerObject.GetComponent<GameController> ();
	}

	void setUpCameraToInitialMap (){
		MainCameraController cameraController = Camera.main.GetComponent<MainCameraController> ();
		cameraController.setCameraBounds (initialMap);
	}

	void readNextMov(){
		mov = new Vector2 (
			Input.GetAxisRaw ("Horizontal"),
			Input.GetAxisRaw ("Vertical")
		);
	}

	void setAnimatorParams(){
		if (mov == Vector2.zero) {
			playerAnimator.SetBool ("walking", false);
		}else{
			playerAnimator.SetFloat ("movX", mov.x);
			playerAnimator.SetFloat ("movY", mov.y);
			playerAnimator.SetBool ("walking", true);
		}
	}

	void movePlayerTowardsMov(){
		playerRigidBody.MovePosition (playerRigidBody.position + mov * speed * Time.deltaTime);
	}
}
